<?php

namespace SMSGateway;


class SMSGatewayHub
{
    // docs at: https://www.smsgatewayhub.com/https-api.aspx
    public static function sendSMS($gateway_fields, $mobile, $message, $test_call)
    {
        $api_key = $gateway_fields['api_key'];
        $sender = $gateway_fields['sender'];

        return self::process_sms($api_key, $sender, $mobile, $message, $test_call);
    }

    public static function process_sms($api_key, $sender, $mobile, $message, $test_call)
    {
        $curl = curl_init();
        $params = array(
            'APIKey' => $api_key,
            'senderid' => $sender,
            'channel' => 2,
            'number' => str_replace("+", "", $mobile),
            'text' => $message,
            'DCS' => 8,
            'flashsms' => 0
        );
        $encoded_query = http_build_query($params);

        curl_setopt($curl, CURLOPT_URL, 'https://www.smsgatewayhub.com/api/mt/SendSMS?' . $encoded_query);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        $result = curl_exec($curl);
        $code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $curl_error = curl_errno($curl);
        curl_close($curl);

        if ($test_call) return $result;

        if ($curl_error !== 0) {
            return false;
        }

        $is_success = 200 <= $code && $code < 300;

        return $is_success;
    }

}
