jQuery(function ($) {
    var ajax_url = dig_ext_script.ajax_url;

    var loader = jQuery(".dig_load_overlay");
    var uploadSize = 0;


    var email_text = dig_ext_script.Email;
    var mob_text = dig_ext_script.Mobileno;
    var mobmail_text = dig_ext_script.EmailMobNo;


    jQuery(".fileupload .btn_select_file").on('click', function (e) {
        e.preventDefault();

        jQuery(this).parent().find('input[type="file"]').click();
    })

    jQuery(".dig-custom-field-type-upload").each(function () {
        var select_file_btn = jQuery(this).find(".btn_select_file");
        var uploaded_file_color = select_file_btn.find(".fileupload-new").css("color");
        select_file_btn.find(".btn_select_file_btn_bg").css({"background-color": uploaded_file_color});

        var dum_inp = jQuery(this).find('.dig_adv_read_only_inp').find('input');
        if (dum_inp.length) {
            var h = dum_inp.outerHeight(true);
            jQuery(this).find('.btn-file').css('line-height', (h - 9) + 'px');
        }
    })

    jQuery('.fileupload').find('input[type="file"]').each(function () {
        var min = null;

        if (jQuery(this).attr('dig-req')) {
            min = Math.max(min, 1);
        }
        if (min && min != null) {
            jQuery(this).closest('form').attr('error', dig_ext_script.uploadAllFiles);

        }
    });

    function checkUpdateMinRequriedFiles(input) {
        var form = input.closest('form');
        var error = false;
        var label = '';
        var min = 0;
        var msg = dig_ext_script.uploadAllFiles;
        form.find('.fileupload').each(function () {


            var inp = jQuery(this).find('input[type="file"]');
            min = inp.attr('min');
            if (jQuery(this).attr('dig-req')) {
                min = Math.max(min, 1);
            }

            if (min == null || !min) return;

            var cfield = inp.closest('.dig-custom-field');
            var field_name = cfield.find('input[type="file"]').attr('f-name');

            var uploaded_data_input = cfield.find(".dig_uploaded_file_data");
            var uploaded_data = uploaded_data_input.val();
            var uploadedFids = {};
            if (uploaded_data.length == 0) {
                error = true;
                uploadedFids = {};
            } else {
                uploadedFids = jQuery.parseJSON(uploaded_data);
                var size = Object.keys(uploadedFids).length;
                if (size < min) {
                    error = true;
                }
            }

            if (error) {
                var label = jQuery(this).closest('.dig-custom-field').find('label').text();
                var m = dig_ext_script.minReqFiles;
                m = m.replace("{{no}}", min);
                m = m.replace("{{field}}", label);
                msg = m;
                return;

            }

        });
        if (error) {
            form.attr('error', msg);
        } else {
            form.removeAttr('error');
        }

    }

    jQuery('.fileupload').find('input').on('change', function (e) {
        hideDigMessage();
        var $fileUpload = jQuery(this);
        var maxSize = jQuery(this).attr('max_size');
        var submitForm = jQuery(this).closest('form');
        submitForm.attr('wait', dig_ext_script.fileUploaded);

        var limit = $fileUpload.attr('limit');

        try {
            var files = jQuery(this).get(0).files;

            for (i = 0; i < files.length; i++) {
                if (files[i].size / 1048576 > maxSize) {
                    throw 'too big';
                }


            }


            if (limit != null) {

                if (parseInt($fileUpload.get(0).files.length) > parseInt(limit)) {
                    showDigErrorMessage("You are only allowed to upload a maximum of " + limit + " files");
                    e.preventDefault();
                    return false;
                }
            }
        } catch (m) {

            showDigErrorMessage('Sorry, file is too large. Please select one that is smaller than ' + maxSize + ' MB');
            e.preventDefault();
            return false;
        }


        var cfield = jQuery(this).closest('.dig-custom-field');
        var field_name = cfield.find('input[type="file"]').attr('f-name');

        var uploaded_data_input = cfield.find(".dig_uploaded_file_data");
        var uploaded_data = uploaded_data_input.val();
        var uploadedFids = {};
        if (uploaded_data.length == 0) {
            uploadedFids = {};
        } else {
            uploadedFids = jQuery.parseJSON(uploaded_data);

            if (limit != null) {
                var size = Object.keys(uploadedFids).length + files.length;
                if (size > limit) {
                    showDigErrorMessage("You are only allowed to upload a maximum of " + limit + " files");
                    e.preventDefault();
                    return false;
                }
            }
        }


        for (i = 0; i < files.length; i++) {
            $fileUpload.closest('.fileupload').find('.file_upload_status').append('' +
                '<tr class="' + filterData(files[i].name) + '">\n' +
                '                    <td class="dig_upload_inprogress">\n' +
                '                        <div class="file_contents">\n' +
                '                        <div class="file_name">' + files[i].name + '</div>\n' +
                '                        <div class="progress dig_sbtncolor"></div>\n' +
                '                        </div>\n' +
                '                    </td>\n' +
                '                    <td class="delete"><img class="close_condition dig_delete_file_upload"  src="' + dig_ext_script.cross + '"></td>\n' +
                '                </tr>' +
                '');
        }


        uploadSize = uploadSize + files.length;
        for (i = 0; i < files.length; i++) {
            var data = new FormData();
            data.append('dig_filenonce', jQuery(".dig_filenonce").val());
            data.append('action', 'dig_upload_file');
            data.append('field_name', field_name);
            data.append('file', files[i]);

            var file_name = filterData(files[i].name);
            var cl = jQuery("." + file_name);
            var prog = cl.find(".progress");
            uploadFile(file_name, cl, prog, data, submitForm, cfield, $fileUpload);
        }

        $fileUpload.val();
    });


    function uploadFile(file_name, cl, prog, data, submitForm, cfield, $fileUpload) {
        var uploaded_data_input = cfield.find(".dig_uploaded_file_data");

        jQuery.ajax({

            type: 'POST',
            url: ajax_url,
            data: data,
            cache: false,
            processData: false,
            contentType: false,
            beforeSend: function () {
                prog.width(0);
            },
            success: function (msg) {
                if (!jQuery("." + file_name).length) {
                    return;
                }


                uploadSize--;
                if (uploadSize == 0) {
                    submitForm.removeAttr('wait');
                }

                cl.find('.dig_upload_inprogress').removeClass('dig_upload_inprogress');

                prog.hide().width(0);
                if (msg.success == true) {
                    cl.attr({
                        'id': msg.data.fid,
                        'nce': msg.data.nonce,
                        'fname': escapeHtml(msg.data.fname),
                        'type': escapeHtml(msg.data.type)
                    }).removeAttr('class');
                    var uploaded_data = uploaded_data_input.val();
                    var uploadedFids = {};
                    if (uploaded_data.length == 0) {
                        uploadedFids = {};
                    } else {
                        uploadedFids = jQuery.parseJSON(uploaded_data);

                    }

                    var fileDetails = {};
                    fileDetails['name'] = msg.data.fname;
                    fileDetails['type'] = msg.data.type;

                    uploadedFids[msg.data.fid] = fileDetails;
                    uploaded_data_input.val(JSON.stringify(uploadedFids));

                    checkUpdateMinRequriedFiles($fileUpload);
                } else {
                    showDigErrorMessage(msg.data.message);
                    cl.remove();
                }
            },
            error: function (error) {
                checkUpdateMinRequriedFiles($fileUpload);
                cl.remove();
                showDigErrorMessage("Error");
                uploadSize--;
                if (uploadSize == 0) {
                    submitForm.removeAttr('disabled');
                }

            },
            xhr: function () {
                var xhr = new window.XMLHttpRequest();

                xhr.upload.addEventListener("progress", function (evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = evt.loaded / evt.total;
                        percentComplete = parseInt(percentComplete * 100);
                        prog.width(percentComplete + "%");


                    }
                }, false);

                return xhr;
            },
        });
    }


    //close_condition
    jQuery(document).on("click", ".dig_delete_file_upload", function () {

        var user_id = jQuery(".current_user_id").val();


        if (!user_id || user_id == 0) {
            deleteFile(jQuery(this));
        } else {
            var delMsg = dig_ext_script.delFinal;

            var fileName = jQuery(this).closest('tr').find('.file_name').text();

            delMsg = delMsg.replace("{{file}}", jQuery.trim(fileName));

            var deleteConfirm = confirm(delMsg);
            if (deleteConfirm == true) {
                deleteFile(jQuery(this));
            }
        }


    });

    function deleteFile($this) {


        var par = $this.closest('tr');


        var fid = par.attr('id');
        var nonce = par.attr('nce');
        var fname = par.attr('fname');

        if (fid == null || !fid) {
            uploadSize--;
            if (uploadSize == 0) {
                $this.closest('form').removeAttr('wait');
            }
        }
        var cfield = $this.closest('.dig-custom-field');


        var field_name = cfield.find('label').first().clone().children().remove().end().text();


        var uploaded_data_input = cfield.find(".dig_uploaded_file_data");
        var uploaded_data = uploaded_data_input.val();
        var uploadedFids = jQuery.parseJSON(uploaded_data);
        if (uploadedFids == null) {
            checkUpdateMinRequriedFiles($this.closest('.dig-custom-field'));
            par.slideUp('fast').remove();
            return;
        }


        if (uploadedFids[fid]) {
            delete uploadedFids[fid];
            uploaded_data_input.val(JSON.stringify(uploadedFids));
        }

        checkUpdateMinRequriedFiles($this.closest('.dig-custom-field'));


        par.slideUp('fast').remove();

        jQuery.ajax({
            type: 'post',
            url: ajax_url,
            data: {
                action: 'dig_delete_file',
                fid: fid,
                nonce: nonce,
                fname: fname,
                field_name: field_name,
                user_id: jQuery(".current_user_id").val()
            },
            success: function (res) {
            }
        });

    }


    function filterData(str) {
        str = jQuery.trim(str.replace(/[\W_]+/g, "_"));
        return str.toLowerCase();
    }


    var change_label_object = null;
    var required_fields = [];
    var required_field_names = [];
    var required_field_ids = [];

    function init(pageLoad) {

        jQuery.each(json, function (key, value) {
            var form;
            then_section = value['then'];
            jQuery.each(then_section, function (index, then) {
                if (then['action'] == 'show_fields') {
                    var field = jQuery("#" + then['value']);
                    var field_inp = field.find('input,textarea,select');
                    field.hide();
                    form = field.closest('form');
                    if (then['value'] == 'dig_cs_email') {
                        form.find('.dig_reg_btn_password').hide();

                    } else if (then['value'] == 'dig_cs_mobilenumber') {
                        form.find('.dig-signup-otp').hide();
                    } else if (then['value'] == 'dig_cs_password') {
                        form.find('.dig_reg_btn_password').hide();
                    }

                    if (field_inp.attr("required") == "required" || field_inp.attr('data-req')) {

                        required_fields.push(then['value']);
                    }
                    field_inp.removeAttr('required').removeAttr('data-req');
                }
            });
            if (pageLoad) {
                update_buttons(form);
            }
        });
        jQuery(".dig_lb_logic[index='0']").hide();
    }

    function update_buttons(form) {
        if (form !== undefined) {
            if (!form.find('.dig-signup-otp').is(':visible') && !form.find('.dig_reg_btn_password').is(':visible')) {
                form.find('.registerbutton').first().show();
            }
            if (!form.find('.dig-signup-otp').is(':visible')) {
                form.find('.dig_reg_btn_password').attr('attr-dis', 0);
            } else {
                form.find('.dig_reg_btn_password').attr('attr-dis', 1);
            }
        }
    }


    jQuery(".dig_lb_value").on('keydown', function (e) {
        var va = jQuery(this).closest('tr').find('.dig_lb_trigger').val();
        if (va == 'is_greater_than' || va == 'is_less_than') {
            if ($.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 190]) !== -1 || (e.keyCode == 65 && e.ctrlKey === true) || (e.keyCode >= 35 && e.keyCode <= 39)) {
                return;
            }

            var charValue = String.fromCharCode(e.keyCode);
            var valid = /^[0-9]+$/.test(charValue);

            if (!valid) {
                e.preventDefault();
            }
        }
    });


    try {

        jQuery('.dig-custom-field-type-time').find('input').attr({
            'type': 'text',
            'dtype': 'time',
            'date': 1
        }).datepicker({
            language: 'en',
            timepicker: true,
            onlyTimepicker: true,
            onSelect: function (formattedDate, date, inst) {
                jQuery(inst.el).trigger('change');
            }
        });

        jQuery('.dig-custom-field-type-daterange').find('input').attr({
            'type': 'text',
            'dtype': 'range',
            'date': 1
        }).datepicker({
            language: 'en',
            timepicker: false,
            multipleDatesSeparator: " - ",
            onSelect: function (formattedDate, date, inst) {
                jQuery(inst.el).trigger('change');
            }
        });

        jQuery('.dig-custom-field-type-dateandtime').find('input').attr({
            'type': 'text',
            'dtype': 'date',
            'date': 1
        }).datepicker({
            language: 'en',
            timepicker: true,
            timeFormat: ' hh:ii aa',
            multipleDatesSeparator: " - ",
            dateFormat: "M dd, yy",
            autoClose: false,
            onSelect: function (formattedDate, date, inst) {
                jQuery(inst.el).trigger('change');
            }
        });

        jQuery('.dig-custom-field-type-dateandtimerange').find('input').attr({
            'type': 'text',
            'dtype': 'range',
            'date': 1,
            'time': 1
        }).datepicker({
            language: 'en',
            timepicker: true,
            timeFormat: ' hh:ii aa',
            multipleDatesSeparator: " - ",
            dateFormat: "M dd, yy",
            autoClose: false,
            onSelect: function (formattedDate, date, inst) {
                jQuery(inst.el).trigger('change');
            }
        });
    } catch (e) {
    }


    json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());


    if (json != null && !jQuery("#dig_reg_custom_field_data").length) {
        init(true);

        var updateIndex = [];
        var form;

        var updatetb = null;
        jQuery(document).on("keydown", ".dig_reg_inputs input,.dig_reg_inputs textarea, .dig_reg_inputs select", function () {
            if (updatetb) {
                clearTimeout(updatetb);
            }
            var $this = jQuery(this);
            updatetb = setTimeout(function () {
                $this.trigger('change');
            }, 200);
        });
        jQuery(window).on('load', function () {
            add_listner();
        });

        function add_listner() {
            jQuery(document).on("change", ".dig_reg_inputs input,.dig_reg_inputs textarea, .dig_reg_inputs select", function () {
                init(false);
                id = jQuery(this).closest("div").attr("id");
                form = jQuery(this).closest('form');

                update_fields(form);
                update_buttons(form);
            });
        }

        function update_fields(form) {
            jQuery.each(json, function (i, value) {

                var if_section = value['if'];
                var then_section = value['then'];
                if (if_section['condition_0'] == undefined) return true;
                var result = true;
                var check;
                jQuery.each(if_section, function (index, condition) {
                    check = true;

                    if (!condition['trigger']) check = false;

                    if (condition['field'] == '') return;


                    var field = jQuery("#" + condition['field']);

                    var inps = field.find("input,select,textarea");

                    var val = inps.val();


                    if (field.hasClass("dig-custom-field-type-checkbox") || field.hasClass("dig-custom-field-type-radio")) {
                        val = "";
                        if (field.is(":visible")) {
                            val = field.find(".dig_opt_mult .selected").find("input:checked").val();
                        }
                    }


                    if (condition['trigger'] == 'is_equal_to') {
                        if (!(val == condition['value'])) check = false;
                    } else if (condition['trigger'] == 'is_not_equal_to') {
                        if (!(val != condition['value'])) check = false;
                    } else if (condition['trigger'] == 'contains') {
                        if (!(val.indexOf(condition['value']) >= 0)) check = false;
                    } else if (condition['trigger'] == 'does_not_contain') {
                        if (!(val.indexOf(condition['value']) == -1)) check = false;
                    } else if (condition['trigger'] == 'is_greater_than') {

                        var dtype = inps.attr('dtype');

                        if (dtype != undefined && dtype) {


                            if (dtype == "range") {
                                var range = val.split('-');
                                if (!range[1]) {
                                    check = false;
                                } else {
                                    var date1 = new Date(range[0]);
                                    var date2 = new Date(range[1]);
                                    var diff = date2 - date1;

                                    var compValue;

                                    if (inps.attr('time')) {
                                        compValue = diff / 1000 / 60 / 24;
                                    } else {
                                        compValue = diff / 1000 / 60 / 60 / 24;
                                    }
                                    if (compValue < condition['value']) {
                                        check = false;
                                    }

                                }
                            } else {
                                var date = new Date(val);
                                var conditionDate = new Date(condition['value']);
                                if (!isDateValid(date) || date < conditionDate) {
                                    check = false;
                                }
                            }


                        } else {
                            if (!jQuery.isNumeric(val)) check = false;
                            else if (parseInt(val) < parseInt(condition['value'])) check = false;
                        }
                    } else if (condition['trigger'] == 'is_less_than') {
                        var dtype = inps.attr('dtype');

                        if (dtype != undefined && dtype) {
                            if (dtype == "range") {
                                var range = val.split('-');
                                if (!range[1]) {
                                    check = false;
                                } else {
                                    var date1 = new Date(range[0]);
                                    var date2 = new Date(range[1]);
                                    var diff = date2 - date1;

                                    var compValue;

                                    if (inps.attr('time')) {
                                        compValue = diff / 1000 / 60 / 24;
                                    } else {
                                        compValue = diff / 1000 / 60 / 60 / 24;
                                    }


                                    if (compValue > condition['value']) {
                                        check = false;
                                    }

                                }
                            } else {
                                var date = new Date(val);
                                var conditionDate = new Date(condition['value']);
                                if (!isDateValid(date) || date > conditionDate) {
                                    check = false;
                                }
                            }
                        } else {
                            if (!jQuery.isNumeric(val)) check = false;
                            else if (parseInt(val) > parseInt(condition['value'])) check = false;
                        }
                    }


                    if (condition['logic'] == 'and')
                        result = result && check;
                    else if (condition['logic'] == 'or')
                        result = result || check;
                });

                if (!result) {


                    if (jQuery.inArray(i, updateIndex) >= 0) {
                        jQuery.each(then_section, function (index, then) {

                            if (then['action'] == 'set_value_of_field') {


                                jQuery("#" + then['field']).find("input,select,textarea").each(function () {
                                    if (jQuery(this).attr('type') != "checkbox" && jQuery(this).attr('type') != "radio") {
                                        jQuery(this).val('');
                                    } else {
                                        jQuery(this).closest('label').removeClass('selected');
                                    }
                                }).trigger('blur');

                            }
                        });
                        updateIndex = jQuery.grep(updateIndex, function (value) {
                            return value != i;
                        });
                    }

                    //if (hidden_object) hidden_object.hide();

                } else {
                    if (jQuery.inArray(i, updateIndex) == -1) {
                        updateIndex.push(i);
                    }
                    if (then_section['result_0'] == undefined) return true;
                    jQuery.each(then_section, function (index, then) {

                        if (then['action'] == '' || then['value'] == '') return;
                        if (then['action'] == 'show_fields') {

                            var field_box = form.find('#' + then['value']);
                            var field_inp = field_box.find('input, select, textarea');

                            if (then['value'] == 'dig_cs_email') {
                                field_box.find('label').text(email_text);
                                form.find('.dig_reg_btn_password').show();
                                field_box.data({'always-show': 1});
                                field_inp.data({'type': 3});
                            } else if (then['value'] == 'dig_cs_mobilenumber') {
                                field_box.find('label').text(mob_text);
                                field_inp.data({'type': 2});
                                form.find('.dig-signup-otp').show();
                            } else if (then['value'] == 'dig_cs_password') {
                                form.find('.dig_reg_btn_password').hide();
                            }

                            field_box.show().find('.optional').hide();

                            if (jQuery.inArray(then['value'], required_fields) !== -1) {
                                field_inp.attr("required", "required");
                            }
                        } else if (then['action'] == 'hide_fields') {

                            var field_box = form.find('#' + then['value']);
                            var field_inp = field_box.find('input, select, textarea');

                            if (then['value'] == 'dig_cs_email') {
                                field_box.find('label').text(email_text);
                                form.find('.dig_reg_btn_password').hide();
                                field_inp.data("type", 3);
                                field_box.removeData('always-show');
                            } else if (then['value'] == 'dig_cs_mobilenumber') {
                                field_box.find('label').text(mob_text);
                                form.find('.dig-signup-otp').hide();
                            } else if (then['value'] == 'dig_cs_password') {
                                form.find('.dig_reg_btn_password').hide();
                            }

                            field_box.hide().find('.optional').hide();
                            if (field_inp.attr("required") == "required" || field_inp.attr('data-req')) {
                                required_fields.push(then['value']);
                            }
                            field_inp.removeAttr("required").removeAttr("data-req");

                        } else if (then['action'] == 'redirect_to') {
                            redirect = then['value'];
                            ajaxurl = ajax_url;
                            var rp = form.find("#digits_redirect_page");
                            if (rp.length) {
                                rp.remove();
                            }
                            form.append('<input type="hidden" id="digits_redirect_page" name="digits_redirect_page" value="' + redirect + '" />');


                        } else if (then['action'] == 'set_value_of_field' || then['action'] == 'change_value_of_field') {
                            var read_only = false;
                            /*if (then['action'] == 'change_value_of_field') {
                                read_only = true;
                            }*/

                            if (!jQuery("#" + then['field']).hasClass("dig-custom-field")) {
                                jQuery("#" + then['field']).find("input").val(then['value']).attr('readonly', read_only).trigger('blur');
                            } else {
                                classes = jQuery("#" + then['field']).attr('class').split(' ');
                                if (jQuery.inArray("dig-custom-field-type-textarea", classes) >= 0) {
                                    jQuery("#" + then['field']).find("textarea").text(then['value']).attr('readonly', read_only).trigger('blur');
                                } else if (jQuery.inArray("dig-custom-field-type-dropdown", classes) >= 0) {
                                    jQuery("#" + then['field']).find("select").children("option").each(function (index1) {
                                        if (jQuery(this).text() == then['value']) jQuery(this).attr("selected", "selected");
                                        else jQuery(this).removeAttr("selected");
                                    });

                                } else if (jQuery.inArray("dig-custom-field-type-checkbox", classes) >= 0) {
                                    values = then['value'].split(', ');

                                    jQuery("#" + then['field']).find(".dig_opt_mult").each(function (index1) {
                                        input_val = jQuery(this).find("input").attr('readonly', read_only).val();
                                        if (jQuery.inArray(input_val, values) >= 0)
                                            jQuery(this).find('label').addClass("selected");
                                        else
                                            jQuery(this).find('label').removeClass("selected");
                                    })
                                } else if (jQuery.inArray("dig-custom-field-type-radio", classes) >= 0) {
                                    jQuery("#" + then['field']).find(".dig_opt_mult").each(function (index1) {
                                        if (jQuery(this).find("input").val() == then['value'])
                                            jQuery(this).find('label').addClass("selected");
                                        else
                                            jQuery(this).find('label').removeClass("selected");
                                    })
                                } else {
                                    jQuery("#" + then['field']).find("input").val(then['value']).attr('readonly', read_only).trigger('blur');
                                }
                            }
                        }
                    });
                }
            });
        }

        jQuery(".dig_reg_inputs").find('input').first().trigger('change');
    }
    jQuery(".dig_reg_lb_cancel").on('click', function () {
        jQuery("#dig_reg_lb_footer").hide();
        jQuery(".dig_reg_lb").animate({right: -800}, function () {
            jQuery(".dig_reg_lb").hide();
        })
    });
    jQuery(".dig_cus_field_done").on('click', function () {
        check = true;
        jQuery(".dig_sb_field").each(function () {
            var sb_field = jQuery(this);
            if (sb_field.is(":visible")) {
                if (sb_field.attr('data-req') == 1) {
                    var is_list = sb_field.attr('data-list');


                    if (is_list == 2) {
                        isCheckList = 1;
                        var sb_list = sb_field.find("input:checked");

                        if (sb_list.length == 0) {
                            check = false;

                        }

                    } else if (is_list == 1) {


                        var sb_list = sb_field.find("ul");
                        if (sb_list.find('li').length == 0) {
                            check = false;

                        }

                    } else {
                        var sb_input = sb_field.find("input");

                        if (sb_input.length > 0) {
                            if (jQuery.trim(sb_input.val()).length == 0) {

                                check = false;
                            }
                        }
                    }


                }
            }
        });
        if (check) {
            fields = getFormData(jQuery(".dig_side_bar").find("input, select"));
            var field_meta_key = jQuery.trim(fields['meta_key'].replace(/\s/g, ''));
            jQuery(".dig_reg_lb_body select.dig_lb_select, .dig_reg_lb_body select.dig_lb_result_type1, .dig_reg_lb_body select.dig_lb_result_type2_field").append('<option value="' + 'dig_cs_' + field_meta_key.toLowerCase() + '">' + fields['label'] + '</option>');
        }
    });
    jQuery(document).on("click", ".dig_cust_field_delete", function () {
        var row = jQuery(this).closest('tr');
        var id = row.attr('id');
        jQuery(".dig_reg_lb_body option[value=" + id + "]").remove();
    });

    jQuery("#dig_add_new_reg_field").click(function () {
        jQuery(".dig_reg_lb").hide();
    });
    jQuery("#dig_open_reg_lb").click(function () {
        jQuery(".dig_side_bar").hide();
        if (jQuery(".dig_reg_lb").is(':visible') && !isUpdate) {
            jQuery(".dig_reg_lb_cancel").trigger('click');
        } else {
            isUpdate = false;
            show_reg_lb();
        }
    })

    function show_reg_lb() {
        jQuery(".dig_reg_lb").show().animate({right: 0}, 'fast', function () {
            jQuery("#dig_reg_lb_footer").show();
        });
    }

    jQuery(document).on("click", ".logic_btn", function () {

        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        condition_num = jQuery(this).parents(".dig_lb_logic").attr("index");
        jQuery(this).siblings(".logic_btn").removeClass("selected_logic");
        jQuery(this).addClass("selected_logic");
        logic = jQuery(this).text();

        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        json["row_" + row_num]["if"]["condition_" + condition_num]["logic"] = logic.toLowerCase();
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();

    });

    jQuery(document).on('click', '.close_condition', function () {
        num = jQuery(this).attr("for");
        condition_count = parseInt(jQuery(this).parents(".condition_section").find(".condition_count").val()) - 1;
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        jQuery(this).parents(".condition_section").find(".condition_count").val(condition_count);
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        if (jQuery(this).parents(".condition_section").find(".condition_count").val() == 0) {
            jQuery(this).parents(".dig_lb_row").find(".dig_lb_result").remove();
            jQuery(this).parents(".dig_lb_row").find(".result_count").val(0);
            json["row_" + row_num]["then"] = {};
        }
        selected_value = jQuery(this).parents(".dig_lb_condition").find("select").eq(0).val();
        selected_text = jQuery(this).parents(".dig_lb_condition").find("select").eq(0).children("option:selected").text();
        jQuery(this).parents(".dig_lb_row").find(".dig_lb_logic").each(function (index) {
            if (jQuery(this).attr("index") == num) {
                jQuery(this).remove();
                delete json["row_" + row_num]["if"]["condition_" + num];
            } else if (jQuery(this).attr("index") > num) {
                n = parseInt(jQuery(this).attr("index"));
                m = n - 1;
                jQuery(this).attr("index", m);
                json["row_" + row_num]["if"]["condition_" + m] = json["row_" + row_num]["if"]["condition_" + n];
                delete json["row_" + row_num]["if"]["condition_" + n];

            }
        });
        if (num == 0) jQuery(this).parents(".dig_lb_row").find(".dig_lb_logic").eq(0).remove();

        jQuery(this).parents(".dig_lb_row").find(".dig_lb_condition").each(function (index) {
            if (jQuery(this).attr("index") == num) {
                jQuery(this).remove();
            } else if (jQuery(this).attr("index") > num) {
                i = parseInt(jQuery(this).attr("index")) - 1;
                jQuery(this).attr("index", i);
                jQuery(this).find(".close_condition").attr("for", i);
            }
        });
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        jQuery(".dig_lb_condition[index='0'] td:first-child").html("IF");
        enableSave();
    });

    jQuery(document).on('click', '.close_result', function () {
        num = jQuery(this).attr("for");
        result_count = parseInt(jQuery(this).parents(".result_section").find(".result_count").val()) - 1;
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        jQuery(this).parents(".result_section").find(".result_count").val(result_count);
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());

        jQuery(this).parents(".result_section").find(".dig_lb_result").each(function (index) {
            if (jQuery(this).attr("index") == num) {
                jQuery(this).remove();
                delete json["row_" + row_num]["then"]["result_" + num];
            } else if (jQuery(this).attr("index") > num) {
                n = parseInt(jQuery(this).attr("index"));
                m = n - 1;
                jQuery(this).attr("index", m);
                jQuery(this).find(".close_result").attr("for", m);
                json["row_" + row_num]["then"]["result_" + m] = json["row_" + row_num]["then"]["result_" + n];
                delete json["row_" + row_num]["then"]["result_" + n];
            }
        });
        jQuery(".dig_lb_result").eq(0).find("td").eq(0).html("THEN");
        jQuery(".dig_lb_result").eq(0).find(".close_row").html('<img for="' + row_num + '" src="' + jQuery("#image_path").val() + 'cross.png">');
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    });

    jQuery(document).on("click", ".add_condition_row", function () {
        index = jQuery(this).parents(".condition_section").find(".condition_count").val();
        if (index == 0) {
            row = '<table style="width: 100%; border-collapse: collapse;"><tbody><input type="hidden" value="0" class="result_count"><tr><td></td><td colspan="4"><div class="add_action_row">+ ADD ACTION ROW</div></td><td></td></tr></tbody></table>'
            jQuery(this).parents(".condition_section").siblings(".result_section").html(row);
        }
        jQuery(this).parents(".condition_section").find(".condition_count").val(parseInt(index) + 1);
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        if (index != 0) {
            row = '<tr class="dig_lb_logic" index="' + index + '"><td></td><td colspan="3" style="text-align: center;" class="border-lr"><span class="logic_btn selected_logic">AND</span><span class="logic_btn">OR</span></td></tr>';
            row += '<tr class="dig_lb_condition" index="' + index + '"><td style="font-weight: bold; vertical-align: middle;"></td><td><select style="display: none;" class="dig_lb_select"><option value="" selected data-display="(field)">Nothing</option>';
        } else {
            row = '<tr class="dig_lb_logic" index="' + index + '"><td></td><td colspan="3" style="text-align: center;"></td></tr>';
            row += '<tr class="dig_lb_condition" index="' + index + '"><td style="font-weight: bold; vertical-align: middle;">IF</td><td><select style="display: none;" class="dig_lb_select"><option value="" selected data-display="(field)">Nothing</option>';
        }

        jQuery("#dig_custom_field_table tbody tr").each(function (index1) {
            id = jQuery(this).attr("id");
            text = jQuery(this).find("label").text();
            row += '<option value="' + id + '">' + text + '</option>';


        });
        row = row + '</select></td><td><select style="display: none;" class="dig_lb_trigger"><option value="" selected="" data-display="(trigger)">Nothing</option><option value="is_equal_to">is equal to</option><option value="is_not_equal_to">is not equal to</option><option value="contains">contains</option><option value="does_not_contain">does not contains</option><option value="is_greater_than">is greater than</option><option value="is_less_than">is less than</option>' +
            '</select></td>';
        row += '<td><input type="text" value="" class="dig_lb_value" placeholder="(value)"></td>';
        row += '<td style="vertical-align: middle;"><img class="close_condition" for="' + index + '" src="' + jQuery("#image_path").val() + 'cross.png"></td></tr>';
        jQuery(this).parents(".condition_section").find(".condition_count").before(row);
        condition = {"logic": "and", "field": "", "name": "", "trigger": "", "value": ""};
        json["row_" + row_num]["if"]["condition_" + index] = condition;
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        digits_settings_select(jQuery('.dig_lb_trigger,.dig_lb_select'));
        enableSave();
    });
    jQuery(document).on("change", ".dig_lb_select", function () {
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        condition_num = jQuery(this).parents(".dig_lb_condition").attr("index");
        id = jQuery(this).val();
        text = jQuery(this).children("option:selected").text();

        if (id == "") text = "";
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        json["row_" + row_num]["if"]["condition_" + condition_num]["field"] = id;
        json["row_" + row_num]["if"]["condition_" + condition_num]["name"] = text;
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    });
    jQuery(document).on("change", ".dig_lb_trigger", function () {
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        condition_num = jQuery(this).parents(".dig_lb_condition").attr("index");
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        json["row_" + row_num]["if"]["condition_" + condition_num]["trigger"] = jQuery(this).val();
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    });
    jQuery(document).on("change", ".dig_lb_value", function () {
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        condition_num = jQuery(this).parents(".dig_lb_condition").attr("index");
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        json["row_" + row_num]["if"]["condition_" + condition_num]["value"] = jQuery(this).val();
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    })
    jQuery(document).on("change", ".dig_lb_action", function () {
        type = jQuery(this).val();
        jQuery(this).parent("td").siblings(".dig_lb_result_section").remove();
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        result_num = jQuery(this).parents(".dig_lb_result").attr("index");
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        if (type == "show_fields" || type == "hide_fields") {
            row = '<td colspan="2" class="dig_lb_result_section"><select class="dig_lb_result_type1" style="display: none;"><option value="" data-display="(field)" selected>Nothing</option>';

            jQuery("#dig_custom_field_table tbody tr").each(function (index) {
                id = jQuery(this).attr("id");
                text = jQuery(this).find("label").text();
                row += '<option value="' + id + '">' + text + '</option>';
            });
            row = row + '</select></td>';
            json["row_" + row_num]["then"]["result_" + result_num]["value"] = "";
        } else if (type == "redirect_to") {
            row = '<td colspan="2" class="dig_lb_result_section"><input type="text" value="" class="dig_lb_result_type3" placeholder="(value)"></td>';
            json["row_" + row_num]["then"]["result_" + result_num]["value"] = "";
        } else if (type == "set_value_of_field" || type == "change_value_of_field") {
            row = '<td class="dig_lb_result_section"><select class="dig_lb_result_type2_field" style="display: none;">';

            jQuery("#dig_custom_field_table tbody tr").each(function (index) {
                id = jQuery(this).attr("id");
                text = jQuery(this).find("label").text();
                row += '<option value="' + id + '" selected>' + text + '</option>';
            });
            row += '</select></td>';
            row += '<td class="dig_lb_result_section"><input type="text" value="" class="dig_lb_result_type2_value" placeholder="(value)"></td>';
            json["row_" + row_num]["then"]["result_" + result_num]["field"] = "";
            json["row_" + row_num]["then"]["result_" + result_num]["value"] = "";
        } else {
            row = '<td colspan="2" class="dig_lb_result_section"><input type="text" value="" class="" placeholder="(value)"></td>';
            json["row_" + row_num]["then"]["result_" + result_num]["value"] = "";
        }
        json["row_" + row_num]["then"]["result_" + result_num]["action"] = type;
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        jQuery(this).parent("td").after(row);
        digits_settings_select(jQuery('.dig_lb_result_type2_field,.dig_lb_result_type1'));
        enableSave();
    })
    jQuery(document).on("change", ".dig_lb_result_type1, .dig_lb_result_type3, .dig_lb_result_type2_value", function () {
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        result_num = jQuery(this).parents(".dig_lb_result").attr("index");
        value = jQuery(this).val();
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        json["row_" + row_num]["then"]["result_" + result_num]["value"] = value;
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    })
    jQuery(document).on("change", ".dig_lb_result_type2_field", function () {
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        result_num = jQuery(this).parents(".dig_lb_result").attr("index");
        value = jQuery(this).val();
        jQuery(this).parent(".dig_lb_result_section").siblings(".dig_lb_result_section").find(".dig_lb_result_type2_value").val("");
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        json["row_" + row_num]["then"]["result_" + result_num]["field"] = value;
        json["row_" + row_num]["then"]["result_" + result_num]["value"] = "";
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    })
    jQuery(document).on("click", ".add_action_row", function () {
        index = jQuery(this).parents(".result_section").find(".result_count").val();
        jQuery(this).parents(".result_section").find(".result_count").val(parseInt(index) + 1);
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        row_num = jQuery(this).parents(".dig_lb_row").attr("for");
        if (index != 0) {
            row = '<tr class="dig_lb_result" index="' + index + '"><td style="font-weight: bold; vertical-align: middle;"></td>';
        } else {
            row = '<tr class="dig_lb_result" index="' + index + '"><td style="font-weight: bold; vertical-align: middle;">THEN</td>';
        }
        row += '<td><select class="dig_lb_action" style="display: none;"><option value="" selected="" data-display="(action)">Nothing</option><option value="show_fields">show fields</option><option value="hide_fields">hide fields</option><option value="set_value_of_field">set value of field</option><option value="change_value_of_field">change value of field</option><option value="redirect_to">redirect to</option></select>';
        row += '</td>';
        row += '<td colspan="2" class="dig_lb_result_section"><input type="text" value="" class="" placeholder="(value)"></td>';
        row += '<td style="vertical-align: middle;"><img class="close_result" for="' + index + '" src="' + jQuery("#image_path").val() + 'cross.png"></td>';
        if (index != 0) {
            row += '<td style="vertical-align: middle;" class="close_row"></td></tr>';
        } else {
            row += '<td style="vertical-align: middle;" class="close_row"><img for="' + row_num + '" src="' + jQuery("#image_path").val() + 'cross.png"></td></tr>';
        }
        jQuery(this).parents(".result_section").find(".result_count").before(row);

        digits_settings_select(jQuery('.dig_lb_action'));

        result = {"action": "", "value": ""};
        json["row_" + row_num]["then"]["result_" + index] = result;
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    })
    jQuery(document).on("click", ".close_row img", function () {
        num = jQuery(this).attr("for");
        row_count = parseInt(jQuery(".row_count").val());
        jQuery(".row_count").val(row_count - 1);
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        if (row_count == 1)
            delete json["row_" + num];
        jQuery(".dig_lb_row").each(function (index) {
            if (jQuery(this).attr("for") == num) {
                jQuery(this).remove();
                delete json["row_" + num];
            } else if (jQuery(this).attr("for") > num) {
                n = parseInt(jQuery(this).attr("for"));
                m = n - 1;
                jQuery(this).attr("for", m);
                jQuery(this).find(".close_row img").attr("for", m);
                json["row_" + m] = json["row_" + n];
                delete json["row_" + n];
            }
        });
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
    });
    jQuery(document).on("click", ".add_logic", function () {
        row_count = jQuery(".row_count").val();
        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        row = '<tr class="dig_lb_row" for="' + row_count + '"><td class="condition_section"><table style="width: 100%; border-collapse: collapse;"><tbody><tr class="dig_lb_condition" index="0"><td style="font-weight: bold; vertical-align: middle;">IF</td><td><select style="display: none;" class="dig_lb_select">';
        row += '<option value="" selected data-display="(field)">Nothing</option>';
        jQuery("#dig_custom_field_table tbody tr").each(function (index) {
            id = jQuery(this).attr("id");
            text = jQuery(this).find("label").text();
            row += '<option value="' + id + '">' + text + '</option>';
        });
        row = row + '</select></td><td><select style="display: none;" class="dig_lb_trigger"><option value="" selected="" data-display="(trigger)">Noting</option><option value="is_equal_to">is equal to</option><option value="is_not_equal_to">is not equal to</option><option value="contains">contains</option><option value="does_not_contain">does not contains</option><option value="is_greater_than">is greater than</option><option value="is_less_than">is less than</option>' +
            '</select></td>';
        row += '<td><input type="text" value="" class="dig_lb_value" placeholder="(value)"></td>';
        row += '<td style="vertical-align: middle;"><img class="close_condition" for="0" src="' + jQuery("#image_path").val() + 'cross.png"></td></tr>';
        row += '<input type="hidden" value="1" class="condition_count"><tr><td></td><td colspan="3"><div class="add_condition_row">+ ADD CONDITION ROW</div></td></tr></tbody></table></td>';
        condition = {"logic": "and", "field": "", "name": "", "trigger": "", "value": ""};
        json["row_" + row_count] = {"if": {"condition_0": condition}};
        row += '<td class="result_section"><table style="width: 100%; border-collapse: collapse;"><tbody><tr class="dig_lb_result" index="0"><td style="font-weight: bold; vertical-align: middle;">THEN</td><td>';
        row += '<select class="dig_lb_action" style="display: none;"><option value="" selected="" data-display="(action)">Nothing</option><option value="show_fields">show fields</option><option value="hide_fields">hide fields</option><option value="set_value_of_field">set value of field</option><option value="change_value_of_field">change value of field</option><option value="redirect_to">redirect to</option></select></td>';
        row += '<td colspan="2" class="dig_lb_result_section"><input type="text" value="" class="" placeholder="(value)"></td><td style="vertical-align: middle;"><img class="close_result" for="0" src="' + jQuery("#image_path").val() + 'cross.png"></td><td style="vertical-align: middle;" class="close_row"><img for="' + row_count + '" src="' + jQuery("#image_path").val() + 'cross.png"></td></tr><input type="hidden" value="1" class="result_count"><tr><td></td><td colspan="4"><div class="add_action_row">+ ADD ACTION ROW</div></td><td></td></tr></tbody></table></td></tr>'
        result = {"action": "", "value": ""};
        json["row_" + row_count] = {"if": {"condition_0": condition}, "then": {"result_0": result}};
        jQuery("#dig_reg_lb").val(JSON.stringify(json));
        enableSave();
        jQuery(".row_count").val(parseInt(row_count) + 1);
        jQuery(this).closest("tr").before(row);

        digits_settings_select(jQuery('.dig_lb_action,.dig_lb_trigger,.dig_lb_select'));

        json = jQuery.parseJSON(jQuery("#dig_reg_lb").val());
        jQuery("#dig_reg_lb").val(JSON.stringify(json));

        enableSave();
    });

    var reg_custom_field_input = jQuery("#dig_reg_custom_field_data");


    jQuery(document).on("change", ".dig_lb_select,.dig_lb_result_type2_field", function () {
        updateLBSelect(jQuery(this));
    });

    jQuery(".dig_lb_select,.dig_lb_result_type2_field").each(function () {
        updateLBSelect(jQuery(this));
    })


    function updateLBSelect(slb) {


        var vid = slb.val();
        var dig_lab = jQuery("#" + vid).attr('dig-lab');


        var field_data = reg_custom_field_input.val();
        if (field_data.length == 0) {
            return;
        }

        var dig_custom_field_data = jQuery.parseJSON(field_data);
        var field = dig_custom_field_data[dig_lab];


        var tr = slb.closest('tr');


        var inp;

        if (slb.hasClass('dig_lb_result_type2_field')) {
            inp = tr.find('.dig_lb_result_type2_value');
        } else {
            inp = tr.find('.dig_lb_value');
        }
        var inp_type = inp.attr('type');


        inp.datepicker().data('datepicker').destroy();
        if (field != null) {
            var type = field['type'];

            if (type == 'dateandtime' || type == 'date' || type == 'time') {

                var onlyTimePicker = false;
                var timepicker = true;
                if (type == 'time') {
                    onlyTimePicker = true;
                }

                if (type == 'date') {
                    timepicker = false;
                }


                inp.val('');
                inp.datepicker({
                    language: 'en',
                    timepicker: timepicker,
                    onlyTimepicker: onlyTimePicker,
                    multipleDatesSeparator: " - ",
                    timeFormat: 'hh:ii aa',
                    topOffset: 42,
                    onSelect: function (formattedDate, date, inst) {
                        jQuery(inst.el).trigger('change');
                    }
                });


                return;
            }

        }

    }

    function enableSave() {
        jQuery(".dig_activation_form").find("button[type='submit']").removeAttr("disabled");
    }

    function getFormData($form) {
        var unindexed_array = $form.serializeArray();
        var indexed_array = {};

        jQuery.map(unindexed_array, function (n, i) {
            indexed_array[n['name']] = n['value'].replace(/<(?:.|\n)*?>/gm, '');
        });
        return indexed_array;
    }

    function removeSpacesAndLowerCase(str) {
        str = jQuery.trim(str.replace(/\s/g, ''));
        return str.toLowerCase();
    }

    function isDateValid(date) {
        // An invalid date object returns NaN for getTime() and NaN is the only
        // object not strictly equal to itself.
        return date.getTime() === date.getTime();
    };


    function escapeHtml(string) {

        var entityMap = {
            '&': '&amp;',
            '<': '&lt;',
            '>': '&gt;',
            '"': '&quot;',
            "'": '&#39;',
            '/': '&#x2F;',
            '`': '&#x60;',
            '=': '&#x3D;'
        };
        return String(string).replace(/[&<>"'`=\/]/g, function (s) {
            return entityMap[s];
        });
    }


});
